// Code generated by Wire. DO NOT EDIT.

//go:generate wire
//+build !wireinject

package main

import (
	"context"
	"os"

	"cloud.google.com/go/storage"
	firebase "firebase.google.com/go"
	"github.com/google/wire"
	"github.com/sirupsen/logrus"
	"google.golang.org/api/option"
)

// Injectors from wire.go:

func InitializeServer() *server {
	fieldLogger := NewLogger()
	bucketHandle := ProvideBucket(fieldLogger)
	mainServerURLGetter := ProvideServerURLGetter()
	firebaseConfigGetter := NewConfigGetter(fieldLogger, bucketHandle, mainServerURLGetter)
	mainServer := NewServer(firebaseConfigGetter, fieldLogger, bucketHandle)
	return mainServer
}

// wire.go:

var confGetterSet = wire.NewSet(
	NewConfigGetter, wire.Bind((*UserConfigGetter)(nil), (*FirebaseConfigGetter)(nil)), ProvideBucket,
	ProvideServerURLGetter)

func NewServer(c UserConfigGetter, l logrus.FieldLogger, b *storage.BucketHandle) *server {
	return &server{
		configGetter: c,
		logger:       l,
		bucket:       b,
	}
}

func NewLogger() logrus.FieldLogger {
	l := logrus.New()
	l.SetOutput(os.Stdout)
	l.SetFormatter(&logrus.JSONFormatter{})
	return l.WithField("app", "entrysound_dir")
}

func NewConfigGetter(logger logrus.FieldLogger, bucket *storage.BucketHandle, baseURL2 serverURLGetter) *FirebaseConfigGetter {
	return &FirebaseConfigGetter{logger: logger, bucket: bucket, BaseURL: baseURL2()}
}

func ProvideBucket(logger logrus.FieldLogger) *storage.BucketHandle {
	config := &firebase.Config{
		StorageBucket: "discord-entrysound.appspot.com",
	}
	opt := option.WithCredentialsFile(*keyFile)
	app, err := firebase.NewApp(context.Background(), config, opt)
	if err != nil {
		panic(err)
	}
	client, err := app.Storage(context.Background())
	if err != nil {
		panic(err)
	}
	bucket, err := client.DefaultBucket()
	if err != nil {
		panic(err)
	}
	return bucket
}

type serverURLGetter func() ServerURL

func ProvideServerURLGetter() serverURLGetter {
	return serverURLGetter(func() ServerURL {
		return ServerURL(*baseURL)
	})
}
